Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 2894)
@@ -2904,759 +3256,749 @@
        INTEGER(iwp)       ::  nysf             !< index of south boundary on former subdomain
        INTEGER(iwp)       ::  nys_on_file      !< index of south boundary on former local domain  
-       INTEGER(iwp)       ::  overlap_count    !< number of overlaps
-  
-       INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nxlfa       !< 
-       INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nxrfa       !< 
-       INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nynfa       !< 
-       INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  nysfa       !< 
-       INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  offset_xa   !< 
-       INTEGER(iwp), DIMENSION(numprocs_previous_run,1000) ::  offset_ya   !< 
-
-
-       LOGICAL                         ::  horizontal_surface !< flag indicating horizontal surfaces
+
+       INTEGER(iwp), SAVE  ::  l           !< index variable for surface type
+
        LOGICAL                         ::  surf_match_def     !< flag indicating that surface element is of default type
        LOGICAL                         ::  surf_match_lsm     !< flag indicating that surface element is of natural type
        LOGICAL                         ::  surf_match_usm     !< flag indicating that surface element is of urban type
-       LOGICAL                         ::  vertical_surface   !< flag indicating vertical surfaces
-
-       TYPE(surf_type), DIMENSION(0:2) ::  surf_h             !< horizontal surface type on file
-       TYPE(surf_type), DIMENSION(0:3) ::  surf_v             !< vertical surface type on file
-
-!
-!--    Read number of respective surface elements on file
-       READ ( 13 )  field_chr
-       IF ( TRIM( field_chr ) /= 'ns_h_on_file' )  THEN
-!
-!--       Add a proper error message
-       ENDIF
-       READ ( 13 ) ns_h_on_file
-
-       READ ( 13 )  field_chr
-       IF ( TRIM( field_chr ) /= 'ns_v_on_file' )  THEN
-!
-!--       Add a proper error message
-       ENDIF
-       READ ( 13 ) ns_v_on_file
-!
-!--    Allocate memory for number of surface elements on file. Please note, 
-!--    these number is not necessarily the same as the final number of surface
-!--    elements on local domain, which is the case if processor topology changes
-!--    during restart runs. 
-!--    Horizontal upward facing
-       surf_h(0)%ns = ns_h_on_file(0)
-       CALL allocate_surface_attributes_h( surf_h(0),                          &
+
+       LOGICAL, INTENT(OUT) ::  found
+
+       LOGICAL, SAVE ::  horizontal_surface !< flag indicating horizontal surfaces
+       LOGICAL, SAVE ::  vertical_surface   !< flag indicating vertical surfaces
+
+       TYPE(surf_type), DIMENSION(0:2), SAVE ::  surf_h             !< horizontal surface type on file
+       TYPE(surf_type), DIMENSION(0:3), SAVE ::  surf_v             !< vertical surface type on file
+
+
+       found              = .TRUE.
+
+
+       SELECT CASE ( restart_string(1:length) )
+
+          CASE ( 'ns_h_on_file' )
+             IF ( kk == 1 )  THEN
+                READ ( 13 )  ns_h_on_file
+
+                IF ( ALLOCATED( surf_h(0)%start_index ) )                      &
+                   CALL deallocate_surface_attributes_h( surf_h(0) )           
+                IF ( ALLOCATED( surf_h(1)%start_index ) )                      &
+                   CALL deallocate_surface_attributes_h( surf_h(1) )           
+                IF ( ALLOCATED( surf_h(2)%start_index ) )                      &
+                   CALL deallocate_surface_attributes_h_top( surf_h(2) )       
+
+!--             Allocate memory for number of surface elements on file. 
+!--             Please note, these number is not necessarily the same as 
+!--             the final number of surface elements on local domain,
+!--             which is the case if processor topology changes during
+!--             restart runs.  
+!--             Horizontal upward facing
+                surf_h(0)%ns = ns_h_on_file(0)
+                CALL allocate_surface_attributes_h( surf_h(0),                 &
+                                        nys_on_file, nyn_on_file,              &
+                                        nxl_on_file, nxr_on_file )
+
+!--             Horizontal downward facing
+                surf_h(1)%ns = ns_h_on_file(1)
+                CALL allocate_surface_attributes_h( surf_h(1),                 &
+                                        nys_on_file, nyn_on_file,              &
+                                        nxl_on_file, nxr_on_file )
+
+!--             Model top
+                surf_h(2)%ns = ns_h_on_file(2)
+                CALL allocate_surface_attributes_h_top( surf_h(2),             &
+                                            nys_on_file, nyn_on_file,          &
+                                            nxl_on_file, nxr_on_file )
+
+!
+!--             Initial setting of flags for horizontal and vertical surfaces,
+!--             will be set after start- and end-indices are read. 
+                horizontal_surface = .FALSE.
+                vertical_surface   = .FALSE.
+
+             ENDIF   
+
+          CASE ( 'ns_v_on_file' )
+             IF ( kk == 1 ) THEN
+                READ ( 13 )  ns_v_on_file
+
+                DO  l = 0, 3
+                   IF ( ALLOCATED( surf_v(l)%start_index ) )                   &
+                      CALL deallocate_surface_attributes_v( surf_v(l) )
+                ENDDO
+
+!--                Vertical surfaces
+                DO  l = 0, 3
+                   surf_v(l)%ns = ns_v_on_file(l)
+                   CALL allocate_surface_attributes_v( surf_v(l),              &
                                            nys_on_file, nyn_on_file,           &
                                            nxl_on_file, nxr_on_file )
-!
-!--    Horizontal downward facing
-       surf_h(1)%ns = ns_h_on_file(1)
-       CALL allocate_surface_attributes_h( surf_h(1),                          &
-                                           nys_on_file, nyn_on_file,           &
-                                           nxl_on_file, nxr_on_file )
-!
-!--    Model top
-       surf_h(2)%ns = ns_h_on_file(2)
-       CALL allocate_surface_attributes_h_top( surf_h(2),                      &
-                                               nys_on_file, nyn_on_file,       &
-                                               nxl_on_file, nxr_on_file )
-!
-!--    Vertical surfaces
-       DO  l = 0, 3
-          surf_v(l)%ns = ns_v_on_file(l)
-          CALL allocate_surface_attributes_v( surf_v(l),                       &
-                                              nys_on_file, nyn_on_file,        &
-                                              nxl_on_file, nxr_on_file )
-       ENDDO
-
-       IF ( initializing_actions == 'read_restart_data'  .OR.                  &
-            initializing_actions == 'cyclic_fill' )  THEN
-!
-!--       Initial setting of flags for horizontal and vertical surfaces, will
-!--       be set after start- and end-indices are read. 
-          horizontal_surface = .FALSE.
-          vertical_surface   = .FALSE.
-
-          READ ( 13 )  field_chr
-
-          DO  WHILE ( TRIM( field_chr ) /= '*** end surf ***' )
-!
-!--          Map data on file as often as needed (data are read only for k=1)
-             DO  kk = 1, overlap_count
-!
-!--             Get the index range of the subdomain on file which overlap with the
-!--             current subdomain
-                nxlf = nxlfa(ii,kk)
-                nxlc = nxlfa(ii,kk) + offset_xa(ii,kk)
-                nxrf = nxrfa(ii,kk)
-                nxrc = nxrfa(ii,kk) + offset_xa(ii,kk)
-                nysf = nysfa(ii,kk)
-                nysc = nysfa(ii,kk) + offset_ya(ii,kk)
-                nynf = nynfa(ii,kk)
-                nync = nynfa(ii,kk) + offset_ya(ii,kk)
-
-                SELECT CASE ( TRIM( field_chr ) )
-
-                   CASE ( 'surf_h(0)%start_index' )
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_h(0)%start_index
-                      l = 0
-                   CASE ( 'surf_h(0)%end_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_h(0)%end_index
-                      horizontal_surface = .TRUE.
-                      vertical_surface   = .FALSE.
-                   CASE ( 'surf_h(0)%us' )         
-                      IF ( ALLOCATED( surf_h(0)%us )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(0)%us
-                   CASE ( 'surf_h(0)%ts' )         
-                      IF ( ALLOCATED( surf_h(0)%ts )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(0)%ts
-                   CASE ( 'surf_h(0)%qs' )         
-                      IF ( ALLOCATED( surf_h(0)%qs )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(0)%qs
-                   CASE ( 'surf_h(0)%ss' )         
-                      IF ( ALLOCATED( surf_h(0)%ss )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(0)%ss
-                   CASE ( 'surf_h(0)%qcs' )         
-                      IF ( ALLOCATED( surf_h(0)%qcs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(0)%qcs
-                   CASE ( 'surf_h(0)%ncs' )         
-                      IF ( ALLOCATED( surf_h(0)%ncs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(0)%ncs
-                   CASE ( 'surf_h(0)%qrs' )         
-                      IF ( ALLOCATED( surf_h(0)%qrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(0)%qrs
-                   CASE ( 'surf_h(0)%nrs' )         
-                      IF ( ALLOCATED( surf_h(0)%nrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(0)%nrs
-                   CASE ( 'surf_h(0)%ol' )         
-                      IF ( ALLOCATED( surf_h(0)%ol )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(0)%ol
-                   CASE ( 'surf_h(0)%rib' )         
-                      IF ( ALLOCATED( surf_h(0)%rib )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(0)%rib
-                   CASE ( 'surf_h(0)%pt_surface' )         
-                      IF ( ALLOCATED( surf_h(0)%pt_surface )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_h(0)%pt_surface
-                   CASE ( 'surf_h(0)%usws' )         
-                      IF ( ALLOCATED( surf_h(0)%usws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(0)%usws
-                   CASE ( 'surf_h(0)%vsws' )         
-                      IF ( ALLOCATED( surf_h(0)%vsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(0)%vsws
-                   CASE ( 'surf_h(0)%shf' )         
-                      IF ( ALLOCATED( surf_h(0)%shf )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(0)%shf
-                   CASE ( 'surf_h(0)%qsws' )         
-                      IF ( ALLOCATED( surf_h(0)%qsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(0)%qsws
-                   CASE ( 'surf_h(0)%ssws' )         
-                      IF ( ALLOCATED( surf_h(0)%ssws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(0)%ssws
-                   CASE ( 'surf_h(0)%css' )
-                      IF ( ALLOCATED( surf_h(0)%css )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(0)%css
-                   CASE ( 'surf_h(0)%cssws' )         
-                      IF ( ALLOCATED( surf_h(0)%cssws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(0)%cssws
-                   CASE ( 'surf_h(0)%qcsws' )         
-                      IF ( ALLOCATED( surf_h(0)%qcsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(0)%qcsws
-                   CASE ( 'surf_h(0)%ncsws' )         
-                      IF ( ALLOCATED( surf_h(0)%ncsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(0)%ncsws
-                   CASE ( 'surf_h(0)%qrsws' )         
-                      IF ( ALLOCATED( surf_h(0)%qrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(0)%qrsws
-                   CASE ( 'surf_h(0)%nrsws' )         
-                      IF ( ALLOCATED( surf_h(0)%nrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(0)%nrsws
-                   CASE ( 'surf_h(0)%sasws' )         
-                      IF ( ALLOCATED( surf_h(0)%sasws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(0)%sasws
-
-                   CASE ( 'surf_h(1)%start_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_h(1)%start_index
-                      l = 1
-                   CASE ( 'surf_h(1)%end_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_h(1)%end_index
-                   CASE ( 'surf_h(1)%us' )         
-                      IF ( ALLOCATED( surf_h(1)%us )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(1)%us
-                   CASE ( 'surf_h(1)%ts' )         
-                      IF ( ALLOCATED( surf_h(1)%ts )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(1)%ts
-                   CASE ( 'surf_h(1)%qs' )         
-                      IF ( ALLOCATED( surf_h(1)%qs )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(1)%qs
-                   CASE ( 'surf_h(1)%ss' )         
-                      IF ( ALLOCATED( surf_h(1)%ss )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(1)%ss
-                   CASE ( 'surf_h(1)%qcs' )         
-                      IF ( ALLOCATED( surf_h(1)%qcs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(1)%qcs
-                   CASE ( 'surf_h(1)%ncs' )         
-                      IF ( ALLOCATED( surf_h(1)%ncs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(1)%ncs
-                   CASE ( 'surf_h(1)%qrs' )         
-                      IF ( ALLOCATED( surf_h(1)%qrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(1)%qrs
-                   CASE ( 'surf_h(1)%nrs' )         
-                      IF ( ALLOCATED( surf_h(1)%nrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(1)%nrs
-                   CASE ( 'surf_h(1)%ol' )         
-                      IF ( ALLOCATED( surf_h(1)%ol )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(1)%ol
-                   CASE ( 'surf_h(1)%rib' )         
-                      IF ( ALLOCATED( surf_h(1)%rib )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(1)%rib
-                   CASE ( 'surf_h(1)%pt_surface' )         
-                      IF ( ALLOCATED( surf_h(1)%pt_surface )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_h(1)%pt_surface
-                   CASE ( 'surf_h(1)%usws' )         
-                      IF ( ALLOCATED( surf_h(1)%usws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(1)%usws
-                   CASE ( 'surf_h(1)%vsws' )         
-                      IF ( ALLOCATED( surf_h(1)%vsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(1)%vsws
-                   CASE ( 'surf_h(1)%shf' )         
-                      IF ( ALLOCATED( surf_h(1)%shf )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(1)%shf
-                   CASE ( 'surf_h(1)%qsws' )         
-                      IF ( ALLOCATED( surf_h(1)%qsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(1)%qsws
-                   CASE ( 'surf_h(1)%ssws' )         
-                      IF ( ALLOCATED( surf_h(1)%ssws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(1)%ssws
-                   CASE ( 'surf_h(1)%css' )
-                      IF ( ALLOCATED( surf_h(1)%css )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(1)%css
-                   CASE ( 'surf_h(1)%cssws' )         
-                      IF ( ALLOCATED( surf_h(1)%cssws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(1)%cssws
-                   CASE ( 'surf_h(1)%qcsws' )         
-                      IF ( ALLOCATED( surf_h(1)%qcsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(1)%qcsws
-                   CASE ( 'surf_h(1)%ncsws' )         
-                      IF ( ALLOCATED( surf_h(1)%ncsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(1)%ncsws
-                   CASE ( 'surf_h(1)%qrsws' )         
-                      IF ( ALLOCATED( surf_h(1)%qrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(1)%qrsws
-                   CASE ( 'surf_h(1)%nrsws' )         
-                      IF ( ALLOCATED( surf_h(1)%nrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(1)%nrsws
-                   CASE ( 'surf_h(1)%sasws' )         
-                      IF ( ALLOCATED( surf_h(1)%sasws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(1)%sasws
-
-                   CASE ( 'surf_h(2)%start_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_h(2)%start_index
-                      l = 2
-                   CASE ( 'surf_h(2)%end_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_h(2)%end_index
-                   CASE ( 'surf_h(2)%us' )         
-                      IF ( ALLOCATED( surf_h(2)%us )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(2)%us
-                   CASE ( 'surf_h(2)%ts' )         
-                      IF ( ALLOCATED( surf_h(2)%ts )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(2)%ts
-                   CASE ( 'surf_h(2)%qs' )        
-                      IF ( ALLOCATED( surf_h(2)%qs )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(2)%qs
-                   CASE ( 'surf_h(2)%ss' )         
-                      IF ( ALLOCATED( surf_h(2)%ss )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(2)%ss
-                   CASE ( 'surf_h(2)%qcs' )         
-                      IF ( ALLOCATED( surf_h(2)%qcs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(2)%qcs
-                   CASE ( 'surf_h(2)%ncs' )         
-                      IF ( ALLOCATED( surf_h(2)%ncs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(2)%ncs
-                   CASE ( 'surf_h(2)%qrs' )         
-                      IF ( ALLOCATED( surf_h(2)%qrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(2)%qrs
-                   CASE ( 'surf_h(2)%nrs' )         
-                      IF ( ALLOCATED( surf_h(2)%nrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(2)%nrs
-                   CASE ( 'surf_h(2)%ol' )         
-                      IF ( ALLOCATED( surf_h(2)%ol )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_h(2)%ol
-                   CASE ( 'surf_h(2)%rib' )         
-                      IF ( ALLOCATED( surf_h(2)%rib )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(2)%rib
-                   CASE ( 'surf_h(2)%usws' )         
-                      IF ( ALLOCATED( surf_h(2)%usws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(2)%usws
-                   CASE ( 'surf_h(2)%vsws' )         
-                      IF ( ALLOCATED( surf_h(2)%vsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(2)%vsws
-                   CASE ( 'surf_h(2)%shf' )         
-                      IF ( ALLOCATED( surf_h(2)%shf )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(2)%shf
-                   CASE ( 'surf_h(2)%qsws' )         
-                      IF ( ALLOCATED( surf_h(2)%qsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(2)%qsws
-                   CASE ( 'surf_h(2)%ssws' )         
-                      IF ( ALLOCATED( surf_h(2)%ssws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_h(2)%ssws
-                   CASE ( 'surf_h(2)%css' )
-                      IF ( ALLOCATED( surf_h(2)%css )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_h(2)%css
-                   CASE ( 'surf_h(2)%cssws' )         
-                      IF ( ALLOCATED( surf_h(2)%cssws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(2)%cssws
-                   CASE ( 'surf_h(2)%qcsws' )         
-                      IF ( ALLOCATED( surf_h(2)%qcsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(2)%qcsws
-                   CASE ( 'surf_h(2)%ncsws' )         
-                      IF ( ALLOCATED( surf_h(2)%ncsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(2)%ncsws
-                   CASE ( 'surf_h(2)%qrsws' )         
-                      IF ( ALLOCATED( surf_h(2)%qrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(2)%qrsws
-                   CASE ( 'surf_h(2)%nrsws' )         
-                      IF ( ALLOCATED( surf_h(2)%nrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(2)%nrsws
-                   CASE ( 'surf_h(2)%sasws' )         
-                      IF ( ALLOCATED( surf_h(2)%sasws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_h(2)%sasws
-
-                   CASE ( 'surf_v(0)%start_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_v(0)%start_index
-                      l = 0
-                      horizontal_surface = .FALSE.
-                      vertical_surface   = .TRUE.
-                   CASE ( 'surf_v(0)%end_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_v(0)%end_index
-                   CASE ( 'surf_v(0)%us' )         
-                      IF ( ALLOCATED( surf_v(0)%us )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(0)%us
-                   CASE ( 'surf_v(0)%ts' )         
-                      IF ( ALLOCATED( surf_v(0)%ts )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(0)%ts
-                   CASE ( 'surf_v(0)%qs' )         
-                      IF ( ALLOCATED( surf_v(0)%qs )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(0)%qs
-                   CASE ( 'surf_v(0)%ss' )         
-                      IF ( ALLOCATED( surf_v(0)%ss )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(0)%ss
-                   CASE ( 'surf_v(0)%qcs' )         
-                      IF ( ALLOCATED( surf_v(0)%qcs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(0)%qcs
-                   CASE ( 'surf_v(0)%ncs' )         
-                      IF ( ALLOCATED( surf_v(0)%ncs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(0)%ncs
-                   CASE ( 'surf_v(0)%qrs' )         
-                      IF ( ALLOCATED( surf_v(0)%qrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(0)%qrs
-                   CASE ( 'surf_v(0)%nrs' )         
-                      IF ( ALLOCATED( surf_v(0)%nrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(0)%nrs
-                   CASE ( 'surf_v(0)%ol' )         
-                      IF ( ALLOCATED( surf_v(0)%ol )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(0)%ol
-                   CASE ( 'surf_v(0)%rib' )         
-                      IF ( ALLOCATED( surf_v(0)%rib )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(0)%rib
-                   CASE ( 'surf_v(0)%pt_surface' )         
-                      IF ( ALLOCATED( surf_v(0)%pt_surface )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_v(0)%pt_surface
-                   CASE ( 'surf_v(0)%shf' )         
-                      IF ( ALLOCATED( surf_v(0)%shf )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(0)%shf
-                   CASE ( 'surf_v(0)%qsws' )         
-                      IF ( ALLOCATED( surf_v(0)%qsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_v(0)%qsws
-                   CASE ( 'surf_v(0)%ssws' )         
-                      IF ( ALLOCATED( surf_v(0)%ssws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_v(0)%ssws
-                   CASE ( 'surf_v(0)%css' ) 
-                      IF ( ALLOCATED( surf_v(0)%css )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(0)%css
-                   CASE ( 'surf_v(0)%cssws' )         
-                      IF ( ALLOCATED( surf_v(0)%cssws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(0)%cssws
-                   CASE ( 'surf_v(0)%qcsws' )         
-                      IF ( ALLOCATED( surf_v(0)%qcsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(0)%qcsws
-                   CASE ( 'surf_v(0)%ncsws' )         
-                      IF ( ALLOCATED( surf_v(0)%ncsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(0)%ncsws
-                   CASE ( 'surf_v(0)%qrsws' )         
-                      IF ( ALLOCATED( surf_v(0)%qrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(0)%qrsws
-                   CASE ( 'surf_v(0)%nrsws' )         
-                      IF ( ALLOCATED( surf_v(0)%nrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(0)%nrsws
-                   CASE ( 'surf_v(0)%sasws' )         
-                      IF ( ALLOCATED( surf_v(0)%sasws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(0)%sasws
-                   CASE ( 'surf_v(0)%mom_uv' )         
-                      IF ( ALLOCATED( surf_v(0)%mom_flux_uv )  .AND.  kk == 1 )&
-                         READ ( 13 )  surf_v(0)%mom_flux_uv
-                   CASE ( 'surf_v(0)%mom_w' )         
-                      IF ( ALLOCATED( surf_v(0)%mom_flux_w )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_v(0)%mom_flux_w
-                   CASE ( 'surf_v(0)%mom_tke' )         
-                      IF ( ALLOCATED( surf_v(0)%mom_flux_tke )  .AND.  kk == 1 )&
-                         READ ( 13 )  surf_v(0)%mom_flux_tke
-
-                   CASE ( 'surf_v(1)%start_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_v(1)%start_index
-                      l = 1
-                   CASE ( 'surf_v(1)%end_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_v(1)%end_index
-                   CASE ( 'surf_v(1)%us' )         
-                      IF ( ALLOCATED( surf_v(1)%us )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(1)%us
-                   CASE ( 'surf_v(1)%ts' )         
-                      IF ( ALLOCATED( surf_v(1)%ts )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(1)%ts
-                   CASE ( 'surf_v(1)%qs' )         
-                      IF ( ALLOCATED( surf_v(1)%qs )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(1)%qs
-                   CASE ( 'surf_v(1)%ss' )         
-                      IF ( ALLOCATED( surf_v(1)%ss )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(1)%ss
-                   CASE ( 'surf_v(1)%qcs' )         
-                      IF ( ALLOCATED( surf_v(1)%qcs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(1)%qcs
-                   CASE ( 'surf_v(1)%ncs' )         
-                      IF ( ALLOCATED( surf_v(1)%ncs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(1)%ncs
-                   CASE ( 'surf_v(1)%qrs' )         
-                      IF ( ALLOCATED( surf_v(1)%qrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(1)%qrs
-                   CASE ( 'surf_v(1)%nrs' )         
-                      IF ( ALLOCATED( surf_v(1)%nrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(1)%nrs
-                   CASE ( 'surf_v(1)%ol' )         
-                      IF ( ALLOCATED( surf_v(1)%ol )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(1)%ol
-                   CASE ( 'surf_v(1)%rib' )         
-                      IF ( ALLOCATED( surf_v(1)%rib )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(1)%rib
-                   CASE ( 'surf_v(1)%pt_surface' )         
-                      IF ( ALLOCATED( surf_v(1)%pt_surface )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_v(1)%pt_surface
-                   CASE ( 'surf_v(1)%shf' )         
-                      IF ( ALLOCATED( surf_v(1)%shf )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(1)%shf
-                   CASE ( 'surf_v(1)%qsws' )         
-                      IF ( ALLOCATED( surf_v(1)%qsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_v(1)%qsws
-                   CASE ( 'surf_v(1)%ssws' )         
-                      IF ( ALLOCATED( surf_v(1)%ssws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_v(1)%ssws
-                   CASE ( 'surf_v(1)%css' ) 
-                      IF ( ALLOCATED( surf_v(1)%css )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(1)%css
-                   CASE ( 'surf_v(1)%cssws' )         
-                      IF ( ALLOCATED( surf_v(1)%cssws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(1)%cssws
-                   CASE ( 'surf_v(1)%qcsws' )         
-                      IF ( ALLOCATED( surf_v(1)%qcsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(1)%qcsws
-                   CASE ( 'surf_v(1)%ncsws' )         
-                      IF ( ALLOCATED( surf_v(1)%ncsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(1)%ncsws
-                   CASE ( 'surf_v(1)%qrsws' )         
-                      IF ( ALLOCATED( surf_v(1)%qrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(1)%qrsws
-                   CASE ( 'surf_v(1)%nrsws' )         
-                      IF ( ALLOCATED( surf_v(1)%nrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(1)%nrsws
-                   CASE ( 'surf_v(1)%sasws' )         
-                      IF ( ALLOCATED( surf_v(1)%sasws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(1)%sasws
-                   CASE ( 'surf_v(1)%mom_uv' )         
-                      IF ( ALLOCATED( surf_v(1)%mom_flux_uv )  .AND.  kk == 1 )&
-                         READ ( 13 )  surf_v(1)%mom_flux_uv
-                   CASE ( 'surf_v(1)%mom_w' )         
-                      IF ( ALLOCATED( surf_v(1)%mom_flux_w )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_v(1)%mom_flux_w
-                   CASE ( 'surf_v(1)%mom_tke' )         
-                      IF ( ALLOCATED( surf_v(1)%mom_flux_tke )  .AND.  kk == 1 )&
-                         READ ( 13 )  surf_v(1)%mom_flux_tke
-
-                   CASE ( 'surf_v(2)%start_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_v(2)%start_index
-                      l = 2
-                   CASE ( 'surf_v(2)%end_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_v(2)%end_index
-                   CASE ( 'surf_v(2)%us' )         
-                      IF ( ALLOCATED( surf_v(2)%us )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(2)%us
-                   CASE ( 'surf_v(2)%ts' )         
-                      IF ( ALLOCATED( surf_v(2)%ts )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(2)%ts
-                   CASE ( 'surf_v(2)%qs' )         
-                      IF ( ALLOCATED( surf_v(2)%qs )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(2)%qs
-                   CASE ( 'surf_v(2)%ss' )         
-                      IF ( ALLOCATED( surf_v(2)%ss )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(2)%ss
-                   CASE ( 'surf_v(2)%qcs' )         
-                      IF ( ALLOCATED( surf_v(2)%qcs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(2)%qcs
-                   CASE ( 'surf_v(2)%ncs' )         
-                      IF ( ALLOCATED( surf_v(2)%ncs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(2)%ncs
-                   CASE ( 'surf_v(2)%qrs' )         
-                      IF ( ALLOCATED( surf_v(2)%qrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(2)%qrs
-                   CASE ( 'surf_v(2)%nrs' )         
-                      IF ( ALLOCATED( surf_v(2)%nrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(2)%nrs
-                   CASE ( 'surf_v(2)%ol' )         
-                      IF ( ALLOCATED( surf_v(2)%ol )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(2)%ol
-                   CASE ( 'surf_v(2)%rib' )         
-                      IF ( ALLOCATED( surf_v(2)%rib )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(2)%rib
-                   CASE ( 'surf_v(2)%pt_surface' )         
-                      IF ( ALLOCATED( surf_v(2)%pt_surface )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_v(2)%pt_surface
-                   CASE ( 'surf_v(2)%shf' )         
-                      IF ( ALLOCATED( surf_v(2)%shf )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(2)%shf
-                   CASE ( 'surf_v(2)%qsws' )         
-                      IF ( ALLOCATED( surf_v(2)%qsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_v(2)%qsws
-                   CASE ( 'surf_v(2)%ssws' )         
-                      IF ( ALLOCATED( surf_v(2)%ssws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_v(2)%ssws
-                   CASE ( 'surf_v(2)%css' ) 
-                      IF ( ALLOCATED( surf_v(2)%css )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(2)%css
-                   CASE ( 'surf_v(2)%cssws' )         
-                      IF ( ALLOCATED( surf_v(2)%cssws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(2)%cssws
-                   CASE ( 'surf_v(2)%qcsws' )         
-                      IF ( ALLOCATED( surf_v(2)%qcsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(2)%qcsws
-                   CASE ( 'surf_v(2)%ncsws' )         
-                      IF ( ALLOCATED( surf_v(2)%ncsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(2)%ncsws
-                   CASE ( 'surf_v(2)%qrsws' )         
-                      IF ( ALLOCATED( surf_v(2)%qrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(2)%qrsws
-                   CASE ( 'surf_v(2)%nrsws' )         
-                      IF ( ALLOCATED( surf_v(2)%nrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(2)%nrsws
-                   CASE ( 'surf_v(2)%sasws' )         
-                      IF ( ALLOCATED( surf_v(2)%sasws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(2)%sasws
-                   CASE ( 'surf_v(2)%mom_uv' )         
-                      IF ( ALLOCATED( surf_v(2)%mom_flux_uv )  .AND.  kk == 1 )&
-                         READ ( 13 )  surf_v(2)%mom_flux_uv
-                   CASE ( 'surf_v(2)%mom_w' )         
-                      IF ( ALLOCATED( surf_v(2)%mom_flux_w )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_v(2)%mom_flux_w
-                   CASE ( 'surf_v(2)%mom_tke' )         
-                      IF ( ALLOCATED( surf_v(2)%mom_flux_tke )  .AND.  kk == 1 )&
-                         READ ( 13 )  surf_v(2)%mom_flux_tke
-
-                   CASE ( 'surf_v(3)%start_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_v(3)%start_index
-                      l = 3
-                   CASE ( 'surf_v(3)%end_index' )   
-                      IF ( kk == 1 )                                           &
-                         READ ( 13 )  surf_v(3)%end_index
-                   CASE ( 'surf_v(3)%us' )         
-                      IF ( ALLOCATED( surf_v(3)%us )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(3)%us
-                   CASE ( 'surf_v(3)%ts' )         
-                      IF ( ALLOCATED( surf_v(3)%ts )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(3)%ts
-                   CASE ( 'surf_v(3)%qs' )        
-                      IF ( ALLOCATED( surf_v(3)%qs )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(3)%qs
-                   CASE ( 'surf_v(3)%ss' )         
-                      IF ( ALLOCATED( surf_v(3)%ss )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(3)%ss
-                   CASE ( 'surf_v(3)%qcs' )         
-                      IF ( ALLOCATED( surf_v(3)%qcs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(3)%qcs
-                   CASE ( 'surf_v(3)%ncs' )         
-                      IF ( ALLOCATED( surf_v(3)%ncs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(3)%ncs
-                   CASE ( 'surf_v(3)%qrs' )         
-                      IF ( ALLOCATED( surf_v(3)%qrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(3)%qrs
-                   CASE ( 'surf_v(3)%nrs' )         
-                      IF ( ALLOCATED( surf_v(3)%nrs )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(3)%nrs
-                   CASE ( 'surf_v(3)%ol' )         
-                      IF ( ALLOCATED( surf_v(3)%ol )  .AND.  kk == 1 )         &
-                         READ ( 13 )  surf_v(3)%ol
-                   CASE ( 'surf_v(3)%rib' )         
-                      IF ( ALLOCATED( surf_v(3)%rib )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(3)%rib
-                   CASE ( 'surf_v(3)%pt_surface' )         
-                      IF ( ALLOCATED( surf_v(3)%pt_surface )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_v(3)%pt_surface
-                   CASE ( 'surf_v(3)%shf' )         
-                      IF ( ALLOCATED( surf_v(3)%shf )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(3)%shf
-                   CASE ( 'surf_v(3)%qsws' )         
-                      IF ( ALLOCATED( surf_v(3)%qsws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_v(3)%qsws
-                   CASE ( 'surf_v(3)%ssws' )         
-                      IF ( ALLOCATED( surf_v(3)%ssws )  .AND.  kk == 1 )       &
-                         READ ( 13 )  surf_v(3)%ssws
-                   CASE ( 'surf_v(3)%css' ) 
-                      IF ( ALLOCATED( surf_v(3)%css )  .AND.  kk == 1 )        &
-                         READ ( 13 )  surf_v(3)%css
-                   CASE ( 'surf_v(3)%cssws' )         
-                      IF ( ALLOCATED( surf_v(3)%cssws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(3)%cssws
-                   CASE ( 'surf_v(3)%qcsws' )         
-                      IF ( ALLOCATED( surf_v(3)%qcsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(3)%qcsws
-                   CASE ( 'surf_v(3)%ncsws' )         
-                      IF ( ALLOCATED( surf_v(3)%ncsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(3)%ncsws
-                   CASE ( 'surf_v(3)%qrsws' )         
-                      IF ( ALLOCATED( surf_v(3)%qrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(3)%qrsws
-                   CASE ( 'surf_v(3)%nrsws' )         
-                      IF ( ALLOCATED( surf_v(3)%nrsws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(3)%nrsws
-                   CASE ( 'surf_v(3)%sasws' )         
-                      IF ( ALLOCATED( surf_v(3)%sasws )  .AND.  kk == 1 )      &
-                         READ ( 13 )  surf_v(3)%sasws
-                   CASE ( 'surf_v(3)%mom_uv' )         
-                      IF ( ALLOCATED( surf_v(3)%mom_flux_uv )  .AND.  kk == 1 )&
-                         READ ( 13 )  surf_v(3)%mom_flux_uv
-                   CASE ( 'surf_v(3)%mom_w' )         
-                      IF ( ALLOCATED( surf_v(3)%mom_flux_w )  .AND.  kk == 1 ) &
-                         READ ( 13 )  surf_v(3)%mom_flux_w
-                   CASE ( 'surf_v(3)%mom_tke' )         
-                      IF ( ALLOCATED( surf_v(3)%mom_flux_tke )  .AND.  kk == 1 )&
-                         READ ( 13 )  surf_v(3)%mom_flux_tke
-
-                END SELECT
-!
-!--             Redistribute surface elements on its respective type. 
-                IF ( horizontal_surface )  THEN
-                   ic = nxlc
-                   DO  i = nxlf, nxrf
-                      jc = nysc
-                      DO  j = nysf, nynf
-
-                         surf_match_def  = surf_def_h(l)%end_index(jc,ic) >=   &
-                                           surf_def_h(l)%start_index(jc,ic)
-                         surf_match_lsm  = ( surf_lsm_h%end_index(jc,ic)  >=   &
-                                             surf_lsm_h%start_index(jc,ic) )   &
-                                     .AND.  l == 0 
-                         surf_match_usm  = ( surf_usm_h%end_index(jc,ic)  >=   &
-                                             surf_usm_h%start_index(jc,ic) )   &
-                                     .AND.  l == 0 
-
-                         IF ( surf_match_def )  THEN
-                            mm = surf_def_h(l)%start_index(jc,ic)
-                            DO  m = surf_h(l)%start_index(j,i),                &
-                                    surf_h(l)%end_index(j,i)
-                               CALL restore_surface_elements( surf_def_h(l),   &
-                                                              mm, surf_h(l), m )
-                               mm = mm + 1
-                            ENDDO
-                         ENDIF
-
-                         IF ( surf_match_lsm )  THEN
-                            mm = surf_lsm_h%start_index(jc,ic)
-                            DO  m = surf_h(l)%start_index(j,i),                &
-                                    surf_h(l)%end_index(j,i)
-                               CALL restore_surface_elements( surf_lsm_h,      &
-                                                              mm, surf_h(l), m )
-                               mm = mm + 1
-                            ENDDO
-                         ENDIF
-
-                         IF ( surf_match_usm )  THEN
-                            mm = surf_usm_h%start_index(jc,ic)
-                            DO  m = surf_h(l)%start_index(j,i),                &
-                                    surf_h(l)%end_index(j,i)
-                               CALL restore_surface_elements( surf_usm_h,      &
-                                                              mm, surf_h(l), m )
-                               mm = mm + 1
-                            ENDDO
-                         ENDIF
-
-                         jc = jc + 1
-                      ENDDO
-                      ic = ic + 1
-                   ENDDO
-                ELSEIF ( vertical_surface )  THEN
-                   ic = nxlc
-                   DO  i = nxlf, nxrf
-                      jc = nysc
-                      DO  j = nysf, nynf
-
-                         surf_match_def  = surf_def_v(l)%end_index(jc,ic) >=   &
-                                           surf_def_v(l)%start_index(jc,ic)
-                         surf_match_lsm  = surf_lsm_v(l)%end_index(jc,ic) >=   &
-                                           surf_lsm_v(l)%start_index(jc,ic)
-                         surf_match_usm  = surf_usm_v(l)%end_index(jc,ic) >=   &
-                                           surf_usm_v(l)%start_index(jc,ic)
-
-                         IF ( surf_match_def )  THEN
-                            mm = surf_def_v(l)%start_index(jc,ic)
-                            DO  m = surf_v(l)%start_index(j,i),                &
-                                    surf_v(l)%end_index(j,i)
-                               CALL restore_surface_elements( surf_def_v(l),   &
-                                                              mm, surf_v(l), m )
-                               mm = mm + 1
-                            ENDDO
-                         ENDIF
-
-                         IF ( surf_match_lsm )  THEN
-                            mm = surf_lsm_v(l)%start_index(jc,ic)
-                            DO  m = surf_v(l)%start_index(j,i),                &
-                                    surf_v(l)%end_index(j,i)
-                               CALL restore_surface_elements( surf_lsm_v(l),   &
-                                                              mm, surf_v(l), m )
-                               mm = mm + 1
-                            ENDDO
-                         ENDIF
-   
-                         IF ( surf_match_usm )  THEN
-                            mm = surf_usm_v(l)%start_index(jc,ic)
-                            DO  m = surf_v(l)%start_index(j,i),                &
-                                    surf_v(l)%end_index(j,i)
-                               CALL restore_surface_elements( surf_usm_v(l),   &
-                                                              mm, surf_v(l), m )
-                               mm = mm + 1
-                            ENDDO
-                         ENDIF
-
-                         jc = jc + 1
-                      ENDDO
-                      ic = ic + 1
+               ENDDO
+
+             ENDIF
+
+          CASE ( 'surf_h(0)%start_index' )
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_h(0)%start_index
+             l = 0
+          CASE ( 'surf_h(0)%end_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_h(0)%end_index
+             horizontal_surface = .TRUE.
+             vertical_surface   = .FALSE.
+          CASE ( 'surf_h(0)%us' )         
+             IF ( ALLOCATED( surf_h(0)%us )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(0)%us
+          CASE ( 'surf_h(0)%ts' )         
+             IF ( ALLOCATED( surf_h(0)%ts )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(0)%ts
+          CASE ( 'surf_h(0)%qs' )         
+             IF ( ALLOCATED( surf_h(0)%qs )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(0)%qs
+          CASE ( 'surf_h(0)%ss' )         
+             IF ( ALLOCATED( surf_h(0)%ss )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(0)%ss
+          CASE ( 'surf_h(0)%qcs' )         
+             IF ( ALLOCATED( surf_h(0)%qcs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(0)%qcs
+          CASE ( 'surf_h(0)%ncs' )         
+             IF ( ALLOCATED( surf_h(0)%ncs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(0)%ncs
+          CASE ( 'surf_h(0)%qrs' )         
+             IF ( ALLOCATED( surf_h(0)%qrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(0)%qrs
+          CASE ( 'surf_h(0)%nrs' )         
+             IF ( ALLOCATED( surf_h(0)%nrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(0)%nrs
+          CASE ( 'surf_h(0)%ol' )         
+             IF ( ALLOCATED( surf_h(0)%ol )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(0)%ol
+          CASE ( 'surf_h(0)%rib' )         
+             IF ( ALLOCATED( surf_h(0)%rib )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(0)%rib
+          CASE ( 'surf_h(0)%pt_surface' )         
+             IF ( ALLOCATED( surf_h(0)%pt_surface )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_h(0)%pt_surface
+          CASE ( 'surf_h(0)%usws' )         
+             IF ( ALLOCATED( surf_h(0)%usws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(0)%usws
+          CASE ( 'surf_h(0)%vsws' )         
+             IF ( ALLOCATED( surf_h(0)%vsws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(0)%vsws
+          CASE ( 'surf_h(0)%shf' )         
+             IF ( ALLOCATED( surf_h(0)%shf )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(0)%shf
+          CASE ( 'surf_h(0)%qsws' )         
+             IF ( ALLOCATED( surf_h(0)%qsws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(0)%qsws
+          CASE ( 'surf_h(0)%ssws' )         
+             IF ( ALLOCATED( surf_h(0)%ssws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(0)%ssws
+          CASE ( 'surf_h(0)%css' )
+             IF ( ALLOCATED( surf_h(0)%css )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(0)%css
+          CASE ( 'surf_h(0)%cssws' )         
+             IF ( ALLOCATED( surf_h(0)%cssws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(0)%cssws
+          CASE ( 'surf_h(0)%qcsws' )         
+             IF ( ALLOCATED( surf_h(0)%qcsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(0)%qcsws
+          CASE ( 'surf_h(0)%ncsws' )         
+             IF ( ALLOCATED( surf_h(0)%ncsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(0)%ncsws
+          CASE ( 'surf_h(0)%qrsws' )         
+             IF ( ALLOCATED( surf_h(0)%qrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(0)%qrsws
+          CASE ( 'surf_h(0)%nrsws' )         
+             IF ( ALLOCATED( surf_h(0)%nrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(0)%nrsws
+          CASE ( 'surf_h(0)%sasws' )         
+             IF ( ALLOCATED( surf_h(0)%sasws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(0)%sasws
+
+          CASE ( 'surf_h(1)%start_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_h(1)%start_index
+             l = 1
+          CASE ( 'surf_h(1)%end_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_h(1)%end_index
+          CASE ( 'surf_h(1)%us' )         
+             IF ( ALLOCATED( surf_h(1)%us )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(1)%us
+          CASE ( 'surf_h(1)%ts' )         
+             IF ( ALLOCATED( surf_h(1)%ts )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(1)%ts
+          CASE ( 'surf_h(1)%qs' )         
+             IF ( ALLOCATED( surf_h(1)%qs )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(1)%qs
+          CASE ( 'surf_h(1)%ss' )         
+             IF ( ALLOCATED( surf_h(1)%ss )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(1)%ss
+          CASE ( 'surf_h(1)%qcs' )         
+             IF ( ALLOCATED( surf_h(1)%qcs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(1)%qcs
+          CASE ( 'surf_h(1)%ncs' )         
+             IF ( ALLOCATED( surf_h(1)%ncs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(1)%ncs
+          CASE ( 'surf_h(1)%qrs' )         
+             IF ( ALLOCATED( surf_h(1)%qrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(1)%qrs
+          CASE ( 'surf_h(1)%nrs' )         
+             IF ( ALLOCATED( surf_h(1)%nrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(1)%nrs
+          CASE ( 'surf_h(1)%ol' )         
+             IF ( ALLOCATED( surf_h(1)%ol )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(1)%ol
+          CASE ( 'surf_h(1)%rib' )         
+             IF ( ALLOCATED( surf_h(1)%rib )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(1)%rib
+          CASE ( 'surf_h(1)%pt_surface' )         
+             IF ( ALLOCATED( surf_h(1)%pt_surface )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_h(1)%pt_surface
+          CASE ( 'surf_h(1)%usws' )         
+             IF ( ALLOCATED( surf_h(1)%usws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(1)%usws
+          CASE ( 'surf_h(1)%vsws' )         
+             IF ( ALLOCATED( surf_h(1)%vsws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(1)%vsws
+          CASE ( 'surf_h(1)%shf' )         
+             IF ( ALLOCATED( surf_h(1)%shf )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(1)%shf
+          CASE ( 'surf_h(1)%qsws' )         
+             IF ( ALLOCATED( surf_h(1)%qsws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(1)%qsws
+          CASE ( 'surf_h(1)%ssws' )         
+             IF ( ALLOCATED( surf_h(1)%ssws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(1)%ssws
+          CASE ( 'surf_h(1)%css' )
+             IF ( ALLOCATED( surf_h(1)%css )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(1)%css
+          CASE ( 'surf_h(1)%cssws' )         
+             IF ( ALLOCATED( surf_h(1)%cssws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(1)%cssws
+          CASE ( 'surf_h(1)%qcsws' )         
+             IF ( ALLOCATED( surf_h(1)%qcsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(1)%qcsws
+          CASE ( 'surf_h(1)%ncsws' )         
+             IF ( ALLOCATED( surf_h(1)%ncsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(1)%ncsws
+          CASE ( 'surf_h(1)%qrsws' )         
+             IF ( ALLOCATED( surf_h(1)%qrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(1)%qrsws
+          CASE ( 'surf_h(1)%nrsws' )         
+             IF ( ALLOCATED( surf_h(1)%nrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(1)%nrsws
+          CASE ( 'surf_h(1)%sasws' )         
+             IF ( ALLOCATED( surf_h(1)%sasws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(1)%sasws
+
+          CASE ( 'surf_h(2)%start_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_h(2)%start_index
+             l = 2
+          CASE ( 'surf_h(2)%end_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_h(2)%end_index
+          CASE ( 'surf_h(2)%us' )         
+             IF ( ALLOCATED( surf_h(2)%us )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(2)%us
+          CASE ( 'surf_h(2)%ts' )         
+             IF ( ALLOCATED( surf_h(2)%ts )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(2)%ts
+          CASE ( 'surf_h(2)%qs' )        
+             IF ( ALLOCATED( surf_h(2)%qs )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(2)%qs
+          CASE ( 'surf_h(2)%ss' )         
+             IF ( ALLOCATED( surf_h(2)%ss )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(2)%ss
+          CASE ( 'surf_h(2)%qcs' )         
+             IF ( ALLOCATED( surf_h(2)%qcs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(2)%qcs
+          CASE ( 'surf_h(2)%ncs' )         
+             IF ( ALLOCATED( surf_h(2)%ncs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(2)%ncs
+          CASE ( 'surf_h(2)%qrs' )         
+             IF ( ALLOCATED( surf_h(2)%qrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(2)%qrs
+          CASE ( 'surf_h(2)%nrs' )         
+             IF ( ALLOCATED( surf_h(2)%nrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(2)%nrs
+          CASE ( 'surf_h(2)%ol' )         
+             IF ( ALLOCATED( surf_h(2)%ol )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_h(2)%ol
+          CASE ( 'surf_h(2)%rib' )         
+             IF ( ALLOCATED( surf_h(2)%rib )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(2)%rib
+          CASE ( 'surf_h(2)%pt_surface' )         
+             IF ( ALLOCATED( surf_h(2)%pt_surface )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_h(2)%pt_surface
+          CASE ( 'surf_h(2)%usws' )         
+             IF ( ALLOCATED( surf_h(2)%usws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(2)%usws
+          CASE ( 'surf_h(2)%vsws' )         
+             IF ( ALLOCATED( surf_h(2)%vsws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(2)%vsws
+          CASE ( 'surf_h(2)%shf' )         
+             IF ( ALLOCATED( surf_h(2)%shf )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(2)%shf
+          CASE ( 'surf_h(2)%qsws' )         
+             IF ( ALLOCATED( surf_h(2)%qsws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(2)%qsws
+          CASE ( 'surf_h(2)%ssws' )         
+             IF ( ALLOCATED( surf_h(2)%ssws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_h(2)%ssws
+          CASE ( 'surf_h(2)%css' )
+             IF ( ALLOCATED( surf_h(2)%css )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(2)%css
+          CASE ( 'surf_h(2)%cssws' )         
+             IF ( ALLOCATED( surf_h(2)%cssws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(2)%cssws
+          CASE ( 'surf_h(2)%qcsws' )         
+             IF ( ALLOCATED( surf_h(2)%qcsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(2)%qcsws
+          CASE ( 'surf_h(2)%ncsws' )         
+             IF ( ALLOCATED( surf_h(2)%ncsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(2)%ncsws
+          CASE ( 'surf_h(2)%qrsws' )         
+             IF ( ALLOCATED( surf_h(2)%qrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(2)%qrsws
+          CASE ( 'surf_h(2)%nrsws' )         
+             IF ( ALLOCATED( surf_h(2)%nrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(2)%nrsws
+          CASE ( 'surf_h(2)%sasws' )         
+             IF ( ALLOCATED( surf_h(2)%sasws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(2)%sasws
+
+          CASE ( 'surf_v(0)%start_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_v(0)%start_index
+             l = 0
+             horizontal_surface = .FALSE.
+             vertical_surface   = .TRUE.
+          CASE ( 'surf_v(0)%end_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_v(0)%end_index
+          CASE ( 'surf_v(0)%us' )         
+             IF ( ALLOCATED( surf_v(0)%us )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(0)%us
+          CASE ( 'surf_v(0)%ts' )         
+             IF ( ALLOCATED( surf_v(0)%ts )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(0)%ts
+          CASE ( 'surf_v(0)%qs' )         
+             IF ( ALLOCATED( surf_v(0)%qs )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(0)%qs
+          CASE ( 'surf_v(0)%ss' )         
+             IF ( ALLOCATED( surf_v(0)%ss )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(0)%ss
+          CASE ( 'surf_v(0)%qcs' )         
+             IF ( ALLOCATED( surf_v(0)%qcs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(0)%qcs
+          CASE ( 'surf_v(0)%ncs' )         
+             IF ( ALLOCATED( surf_v(0)%ncs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(0)%ncs
+          CASE ( 'surf_v(0)%qrs' )         
+             IF ( ALLOCATED( surf_v(0)%qrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(0)%qrs
+          CASE ( 'surf_v(0)%nrs' )         
+             IF ( ALLOCATED( surf_v(0)%nrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(0)%nrs
+          CASE ( 'surf_v(0)%ol' )         
+             IF ( ALLOCATED( surf_v(0)%ol )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(0)%ol
+          CASE ( 'surf_v(0)%rib' )         
+             IF ( ALLOCATED( surf_v(0)%rib )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(0)%rib
+          CASE ( 'surf_v(0)%pt_surface' )         
+             IF ( ALLOCATED( surf_v(0)%pt_surface )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_v(0)%pt_surface
+          CASE ( 'surf_v(0)%shf' )         
+             IF ( ALLOCATED( surf_v(0)%shf )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(0)%shf
+          CASE ( 'surf_v(0)%qsws' )         
+             IF ( ALLOCATED( surf_v(0)%qsws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_v(0)%qsws
+          CASE ( 'surf_v(0)%ssws' )         
+             IF ( ALLOCATED( surf_v(0)%ssws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_v(0)%ssws
+          CASE ( 'surf_v(0)%css' ) 
+             IF ( ALLOCATED( surf_v(0)%css )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(0)%css
+          CASE ( 'surf_v(0)%cssws' )         
+             IF ( ALLOCATED( surf_v(0)%cssws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(0)%cssws
+          CASE ( 'surf_v(0)%qcsws' )         
+             IF ( ALLOCATED( surf_v(0)%qcsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(0)%qcsws
+          CASE ( 'surf_v(0)%ncsws' )         
+             IF ( ALLOCATED( surf_v(0)%ncsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(0)%ncsws
+          CASE ( 'surf_v(0)%qrsws' )         
+             IF ( ALLOCATED( surf_v(0)%qrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(0)%qrsws
+          CASE ( 'surf_v(0)%nrsws' )         
+             IF ( ALLOCATED( surf_v(0)%nrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(0)%nrsws
+          CASE ( 'surf_v(0)%sasws' )         
+             IF ( ALLOCATED( surf_v(0)%sasws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(0)%sasws
+          CASE ( 'surf_v(0)%mom_uv' )         
+             IF ( ALLOCATED( surf_v(0)%mom_flux_uv )  .AND.  kk == 1 )         &
+                READ ( 13 )  surf_v(0)%mom_flux_uv
+          CASE ( 'surf_v(0)%mom_w' )         
+             IF ( ALLOCATED( surf_v(0)%mom_flux_w )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_v(0)%mom_flux_w
+          CASE ( 'surf_v(0)%mom_tke' )         
+             IF ( ALLOCATED( surf_v(0)%mom_flux_tke )  .AND.  kk == 1 )        &
+                READ ( 13 )  surf_v(0)%mom_flux_tke
+
+          CASE ( 'surf_v(1)%start_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_v(1)%start_index
+             l = 1
+          CASE ( 'surf_v(1)%end_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_v(1)%end_index
+          CASE ( 'surf_v(1)%us' )         
+             IF ( ALLOCATED( surf_v(1)%us )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(1)%us
+          CASE ( 'surf_v(1)%ts' )         
+             IF ( ALLOCATED( surf_v(1)%ts )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(1)%ts
+          CASE ( 'surf_v(1)%qs' )         
+             IF ( ALLOCATED( surf_v(1)%qs )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(1)%qs
+          CASE ( 'surf_v(1)%ss' )         
+             IF ( ALLOCATED( surf_v(1)%ss )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(1)%ss
+          CASE ( 'surf_v(1)%qcs' )         
+             IF ( ALLOCATED( surf_v(1)%qcs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(1)%qcs
+          CASE ( 'surf_v(1)%ncs' )         
+             IF ( ALLOCATED( surf_v(1)%ncs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(1)%ncs
+          CASE ( 'surf_v(1)%qrs' )         
+             IF ( ALLOCATED( surf_v(1)%qrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(1)%qrs
+          CASE ( 'surf_v(1)%nrs' )         
+             IF ( ALLOCATED( surf_v(1)%nrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(1)%nrs
+          CASE ( 'surf_v(1)%ol' )         
+             IF ( ALLOCATED( surf_v(1)%ol )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(1)%ol
+          CASE ( 'surf_v(1)%rib' )         
+             IF ( ALLOCATED( surf_v(1)%rib )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(1)%rib
+          CASE ( 'surf_v(1)%pt_surface' )         
+             IF ( ALLOCATED( surf_v(1)%pt_surface )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_v(1)%pt_surface
+          CASE ( 'surf_v(1)%shf' )         
+             IF ( ALLOCATED( surf_v(1)%shf )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(1)%shf
+          CASE ( 'surf_v(1)%qsws' )         
+             IF ( ALLOCATED( surf_v(1)%qsws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_v(1)%qsws
+          CASE ( 'surf_v(1)%ssws' )         
+             IF ( ALLOCATED( surf_v(1)%ssws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_v(1)%ssws
+          CASE ( 'surf_v(1)%css' ) 
+             IF ( ALLOCATED( surf_v(1)%css )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(1)%css
+          CASE ( 'surf_v(1)%cssws' )         
+             IF ( ALLOCATED( surf_v(1)%cssws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(1)%cssws
+          CASE ( 'surf_v(1)%qcsws' )         
+             IF ( ALLOCATED( surf_v(1)%qcsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(1)%qcsws
+          CASE ( 'surf_v(1)%ncsws' )         
+             IF ( ALLOCATED( surf_v(1)%ncsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(1)%ncsws
+          CASE ( 'surf_v(1)%qrsws' )         
+             IF ( ALLOCATED( surf_v(1)%qrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(1)%qrsws
+          CASE ( 'surf_v(1)%nrsws' )         
+             IF ( ALLOCATED( surf_v(1)%nrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(1)%nrsws
+          CASE ( 'surf_v(1)%sasws' )         
+             IF ( ALLOCATED( surf_v(1)%sasws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(1)%sasws
+          CASE ( 'surf_v(1)%mom_uv' )         
+             IF ( ALLOCATED( surf_v(1)%mom_flux_uv )  .AND.  kk == 1 )         &
+                READ ( 13 )  surf_v(1)%mom_flux_uv
+          CASE ( 'surf_v(1)%mom_w' )         
+             IF ( ALLOCATED( surf_v(1)%mom_flux_w )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_v(1)%mom_flux_w
+          CASE ( 'surf_v(1)%mom_tke' )         
+             IF ( ALLOCATED( surf_v(1)%mom_flux_tke )  .AND.  kk == 1 )        &
+                READ ( 13 )  surf_v(1)%mom_flux_tke
+
+          CASE ( 'surf_v(2)%start_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_v(2)%start_index
+             l = 2
+          CASE ( 'surf_v(2)%end_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_v(2)%end_index
+          CASE ( 'surf_v(2)%us' )         
+             IF ( ALLOCATED( surf_v(2)%us )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(2)%us
+          CASE ( 'surf_v(2)%ts' )         
+             IF ( ALLOCATED( surf_v(2)%ts )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(2)%ts
+          CASE ( 'surf_v(2)%qs' )         
+             IF ( ALLOCATED( surf_v(2)%qs )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(2)%qs
+          CASE ( 'surf_v(2)%ss' )         
+             IF ( ALLOCATED( surf_v(2)%ss )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(2)%ss
+          CASE ( 'surf_v(2)%qcs' )         
+             IF ( ALLOCATED( surf_v(2)%qcs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(2)%qcs
+          CASE ( 'surf_v(2)%ncs' )         
+             IF ( ALLOCATED( surf_v(2)%ncs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(2)%ncs
+          CASE ( 'surf_v(2)%qrs' )         
+             IF ( ALLOCATED( surf_v(2)%qrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(2)%qrs
+          CASE ( 'surf_v(2)%nrs' )         
+             IF ( ALLOCATED( surf_v(2)%nrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(2)%nrs
+          CASE ( 'surf_v(2)%ol' )         
+             IF ( ALLOCATED( surf_v(2)%ol )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(2)%ol
+          CASE ( 'surf_v(2)%rib' )         
+             IF ( ALLOCATED( surf_v(2)%rib )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(2)%rib
+          CASE ( 'surf_v(2)%pt_surface' )         
+             IF ( ALLOCATED( surf_v(2)%pt_surface )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_v(2)%pt_surface
+          CASE ( 'surf_v(2)%shf' )         
+             IF ( ALLOCATED( surf_v(2)%shf )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(2)%shf
+          CASE ( 'surf_v(2)%qsws' )         
+             IF ( ALLOCATED( surf_v(2)%qsws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_v(2)%qsws
+          CASE ( 'surf_v(2)%ssws' )         
+             IF ( ALLOCATED( surf_v(2)%ssws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_v(2)%ssws
+          CASE ( 'surf_v(2)%css' ) 
+             IF ( ALLOCATED( surf_v(2)%css )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(2)%css
+          CASE ( 'surf_v(2)%cssws' )         
+             IF ( ALLOCATED( surf_v(2)%cssws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(2)%cssws
+          CASE ( 'surf_v(2)%qcsws' )         
+             IF ( ALLOCATED( surf_v(2)%qcsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(2)%qcsws
+          CASE ( 'surf_v(2)%ncsws' )         
+             IF ( ALLOCATED( surf_v(2)%ncsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(2)%ncsws
+          CASE ( 'surf_v(2)%qrsws' )         
+             IF ( ALLOCATED( surf_v(2)%qrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(2)%qrsws
+          CASE ( 'surf_v(2)%nrsws' )         
+             IF ( ALLOCATED( surf_v(2)%nrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(2)%nrsws
+          CASE ( 'surf_v(2)%sasws' )         
+             IF ( ALLOCATED( surf_v(2)%sasws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(2)%sasws
+          CASE ( 'surf_v(2)%mom_uv' )         
+             IF ( ALLOCATED( surf_v(2)%mom_flux_uv )  .AND.  kk == 1 )         &
+                READ ( 13 )  surf_v(2)%mom_flux_uv
+          CASE ( 'surf_v(2)%mom_w' )         
+             IF ( ALLOCATED( surf_v(2)%mom_flux_w )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_v(2)%mom_flux_w
+          CASE ( 'surf_v(2)%mom_tke' )         
+             IF ( ALLOCATED( surf_v(2)%mom_flux_tke )  .AND.  kk == 1 )        &
+                READ ( 13 )  surf_v(2)%mom_flux_tke
+
+          CASE ( 'surf_v(3)%start_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_v(3)%start_index
+             l = 3
+          CASE ( 'surf_v(3)%end_index' )   
+             IF ( kk == 1 )                                                    &
+                READ ( 13 )  surf_v(3)%end_index
+          CASE ( 'surf_v(3)%us' )         
+             IF ( ALLOCATED( surf_v(3)%us )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(3)%us
+          CASE ( 'surf_v(3)%ts' )         
+             IF ( ALLOCATED( surf_v(3)%ts )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(3)%ts
+          CASE ( 'surf_v(3)%qs' )        
+             IF ( ALLOCATED( surf_v(3)%qs )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(3)%qs
+          CASE ( 'surf_v(3)%ss' )         
+             IF ( ALLOCATED( surf_v(3)%ss )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(3)%ss
+          CASE ( 'surf_v(3)%qcs' )         
+             IF ( ALLOCATED( surf_v(3)%qcs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(3)%qcs
+          CASE ( 'surf_v(3)%ncs' )         
+             IF ( ALLOCATED( surf_v(3)%ncs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(3)%ncs
+          CASE ( 'surf_v(3)%qrs' )         
+             IF ( ALLOCATED( surf_v(3)%qrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(3)%qrs
+          CASE ( 'surf_v(3)%nrs' )         
+             IF ( ALLOCATED( surf_v(3)%nrs )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(3)%nrs
+          CASE ( 'surf_v(3)%ol' )         
+             IF ( ALLOCATED( surf_v(3)%ol )  .AND.  kk == 1 )                  &
+                READ ( 13 )  surf_v(3)%ol
+          CASE ( 'surf_v(3)%rib' )         
+             IF ( ALLOCATED( surf_v(3)%rib )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(3)%rib
+          CASE ( 'surf_v(3)%pt_surface' )         
+             IF ( ALLOCATED( surf_v(3)%pt_surface )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_v(3)%pt_surface
+          CASE ( 'surf_v(3)%shf' )         
+             IF ( ALLOCATED( surf_v(3)%shf )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(3)%shf
+          CASE ( 'surf_v(3)%qsws' )         
+             IF ( ALLOCATED( surf_v(3)%qsws )  .AND.  kk == 1 )                & 
+                READ ( 13 )  surf_v(3)%qsws
+          CASE ( 'surf_v(3)%ssws' )         
+             IF ( ALLOCATED( surf_v(3)%ssws )  .AND.  kk == 1 )                &
+                READ ( 13 )  surf_v(3)%ssws
+          CASE ( 'surf_v(3)%css' ) 
+             IF ( ALLOCATED( surf_v(3)%css )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_v(3)%css
+          CASE ( 'surf_v(3)%cssws' )         
+             IF ( ALLOCATED( surf_v(3)%cssws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(3)%cssws
+          CASE ( 'surf_v(3)%qcsws' )         
+             IF ( ALLOCATED( surf_v(3)%qcsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(3)%qcsws
+          CASE ( 'surf_v(3)%ncsws' )         
+             IF ( ALLOCATED( surf_v(3)%ncsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(3)%ncsws
+          CASE ( 'surf_v(3)%qrsws' )         
+             IF ( ALLOCATED( surf_v(3)%qrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(3)%qrsws
+          CASE ( 'surf_v(3)%nrsws' )         
+             IF ( ALLOCATED( surf_v(3)%nrsws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(3)%nrsws
+          CASE ( 'surf_v(3)%sasws' )         
+             IF ( ALLOCATED( surf_v(3)%sasws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_v(3)%sasws
+          CASE ( 'surf_v(3)%mom_uv' )         
+             IF ( ALLOCATED( surf_v(3)%mom_flux_uv )  .AND.  kk == 1 )         &
+                READ ( 13 )  surf_v(3)%mom_flux_uv
+          CASE ( 'surf_v(3)%mom_w' )         
+             IF ( ALLOCATED( surf_v(3)%mom_flux_w )  .AND.  kk == 1 )          &
+                READ ( 13 )  surf_v(3)%mom_flux_w
+          CASE ( 'surf_v(3)%mom_tke' )         
+             IF ( ALLOCATED( surf_v(3)%mom_flux_tke )  .AND.  kk == 1 )        &
+                READ ( 13 )  surf_v(3)%mom_flux_tke
+
+          CASE DEFAULT
+
+                found = .FALSE.
+
+       END SELECT
+
+!
+!--    Redistribute surface elements on its respective type. 
+       IF ( horizontal_surface )  THEN
+          ic = nxlc
+          DO  i = nxlf, nxrf
+             jc = nysc
+             DO  j = nysf, nynf
+
+                surf_match_def  = surf_def_h(l)%end_index(jc,ic) >=            &
+                                  surf_def_h(l)%start_index(jc,ic)
+                surf_match_lsm  = ( surf_lsm_h%end_index(jc,ic)  >=            &
+                                    surf_lsm_h%start_index(jc,ic) )            &
+                            .AND.  l == 0 
+                surf_match_usm  = ( surf_usm_h%end_index(jc,ic)  >=            &
+                                    surf_usm_h%start_index(jc,ic) )            &
+                            .AND.  l == 0 
+
+                IF ( surf_match_def )  THEN
+                   mm = surf_def_h(l)%start_index(jc,ic)
+                   DO  m = surf_h(l)%start_index(j,i),                         &
+                           surf_h(l)%end_index(j,i)
+                      CALL restore_surface_elements( surf_def_h(l),            &
+                                                     mm, surf_h(l), m )
+                      mm = mm + 1
                    ENDDO
                 ENDIF
 
+                IF ( surf_match_lsm )  THEN
+                   mm = surf_lsm_h%start_index(jc,ic)
+                   DO  m = surf_h(l)%start_index(j,i),                         &
+                           surf_h(l)%end_index(j,i)
+                      CALL restore_surface_elements( surf_lsm_h,               &
+                                                     mm, surf_h(l), m )
+                      mm = mm + 1
+                   ENDDO
+                ENDIF
+
+                IF ( surf_match_usm )  THEN
+                   mm = surf_usm_h%start_index(jc,ic)
+                   DO  m = surf_h(l)%start_index(j,i),                         &
+                           surf_h(l)%end_index(j,i)
+                      CALL restore_surface_elements( surf_usm_h,               &
+                                                     mm, surf_h(l), m )
+                      mm = mm + 1
+                   ENDDO
+                ENDIF
+
+                jc = jc + 1
              ENDDO
-
-             READ ( 13 )  field_chr
-
+             ic = ic + 1
           ENDDO
-
+       ELSEIF ( vertical_surface )  THEN
+          ic = nxlc
+          DO  i = nxlf, nxrf
+             jc = nysc
+             DO  j = nysf, nynf
+
+                surf_match_def  = surf_def_v(l)%end_index(jc,ic) >=            &
+                                  surf_def_v(l)%start_index(jc,ic)
+                surf_match_lsm  = surf_lsm_v(l)%end_index(jc,ic) >=            &
+                                  surf_lsm_v(l)%start_index(jc,ic)
+                surf_match_usm  = surf_usm_v(l)%end_index(jc,ic) >=            &
+                                  surf_usm_v(l)%start_index(jc,ic)
+
+                IF ( surf_match_def )  THEN
+                   mm = surf_def_v(l)%start_index(jc,ic)
+                   DO  m = surf_v(l)%start_index(j,i),                         &
+                           surf_v(l)%end_index(j,i)
+                      CALL restore_surface_elements( surf_def_v(l),            &
+                                                     mm, surf_v(l), m )
+                      mm = mm + 1
+                   ENDDO
+                ENDIF
+
+                IF ( surf_match_lsm )  THEN
+                   mm = surf_lsm_v(l)%start_index(jc,ic)
+                   DO  m = surf_v(l)%start_index(j,i),                         &
+                           surf_v(l)%end_index(j,i)
+                      CALL restore_surface_elements( surf_lsm_v(l),            &
+                                                     mm, surf_v(l), m )
+                      mm = mm + 1
+                   ENDDO
+                ENDIF
+
+                IF ( surf_match_usm )  THEN
+                   mm = surf_usm_v(l)%start_index(jc,ic)
+                   DO  m = surf_v(l)%start_index(j,i),                         &
+                           surf_v(l)%end_index(j,i)
+                      CALL restore_surface_elements( surf_usm_v(l),            &
+                                                     mm, surf_v(l), m )
+                      mm = mm + 1
+                   ENDDO
+                ENDIF
+
+                jc = jc + 1
+             ENDDO
+             ic = ic + 1
+          ENDDO
        ENDIF
 
-       CONTAINS
+
+    CONTAINS
 !------------------------------------------------------------------------------!
 ! Description:
